/*
 * 
 * Vericon version 4.3. Generated Sat Sep 12 13:10:22 2015
 * Auto generated testbench
 *
 */

// Freeware September 2015, Fen Logic Ltd.
// This code is free and is delivered 'as is'.
// It comes without any warranty, to the extent permitted by applicable law.
// There are no restrictions to any use or re-use of this code
// in any form or shape. It would be nice if you keep my company name
// in the source or modified source code but even that is not
// required as I can't check it anyway.
// But the code comes with no warranties or guarantees whatsoever.

module dpm_test;

localparam WCLK_PERIOD=100;
localparam RCLK_PERIOD=123;

localparam WIDTH= 8; // width in bits
localparam L2D  = 8; // Log 2 Depth, 8 = 256 deep 
                     // Simulation parameters
localparam CLEAR= 0;
localparam CHECK= 1;
localparam FILE = "../tb/xpm_test.pattern";


reg              a_clk;    // clock  
reg              a_enable; // enable               
reg              a_write;  // write access 
reg    [L2D-1:0] a_adrs;   // address
reg  [WIDTH-1:0] a_wdata;  // write data
wire [WIDTH-1:0] a_rdata;  // read data
   
reg              b_clk;    // clock  
reg              b_enable; // enable               
reg              b_write;  // write access 
reg    [L2D-1:0] b_adrs;   // address
reg  [WIDTH-1:0] b_wdata;  // write data
wire [WIDTH-1:0] b_rdata;  // read data 

// testbench
reg    a_we,b_we;


   initial
   begin

      a_clk     = 1'b0;
      a_enable  = 1'b1;
      a_write   = 1'b0;
      a_adrs    = 'b0;
      a_wdata   = 'b0;
   
      b_clk     = 1'b0;
      b_enable  = 1'b1;
      b_write   = 1'b0;
      b_adrs    = 'b0;
      b_wdata   = 'b0;
      a_we = 0;
      b_we = 0;
      #500;
      a_we = 1'b1;
//      #15000;
      #200;
      b_we = 1'b0;
      #15000;
      a_we = 1'b1;
      b_we = 1'b0;
      #1500000;
      b_we = 1'b0;
      #15000 $stop;  
   end


dpm
   #(
      .WIDTH (WIDTH),  // width in bits
      .L2D   (L2D)  ,  // Log 2 Depth, 8 = 256 deep 
      // Simulation parameters
      .CLEAR (CLEAR),
      .FILE  (FILE),
      .CHECK (CHECK)
   ) // parameters
dpm_0 (
      .a_clk   (a_clk),    // clock  
      .a_enable(a_enable), // enable               
      .a_write (a_write),  // write access 
      .a_adrs  (a_adrs),   // address
      .a_wdata (a_wdata),  // write data
      .a_rdata (a_rdata),  // read data
   
      .b_clk   (b_clk),    // clock  
      .b_enable(b_enable), // enable               
      .b_write (b_write),  // write access 
      .b_adrs  (b_adrs),   // address
      .b_wdata (b_wdata),  // write data
      .b_rdata (b_rdata) 
   );


   // Port A
   always @(posedge a_clk)
   begin
      if (a_we)
      begin
         a_adrs  <= a_adrs + 1;
         a_wdata <= a_wdata + 1;
         a_write <= 1'b1; // ~a_write;
      end
      else
      begin
         a_adrs  <= a_adrs + 1;
         a_write <= 1'b0;
      end     
   end

   // Port B
   always @(posedge b_clk)
   begin
      if (b_we)
      begin
         b_adrs  <= b_adrs + 1;
         b_wdata <= b_wdata + 1;
         b_write <= 1'b1; // ~b_write;
      end
      else
      begin
         b_adrs  <= b_adrs + 1;
         b_write <= 1'b0;
      end     
   end


   // Generate clocks.
   initial
   begin
      a_clk = 1'b0;
      forever
         #(WCLK_PERIOD/2) a_clk = ~a_clk;
   end
   // Generate read clock.
   initial
   begin
      b_clk = 1'b0;
      forever
         #(RCLK_PERIOD/2)  b_clk = ~ b_clk;
   end


endmodule
