/*
 * 
 * Vericon version 4.3. Generated Sat Sep 12 11:31:31 2015
 * Auto generated testbench
 *
 */
 
// Freeware September 2015, Fen Logic Ltd.
// This code is free and is delivered 'as is'.
// It comes without any warranty, to the extent permitted by applicable law.
// There are no restrictions to any use or re-use of this code
// in any form or shape. It would be nice if you keep my company name
// in the source or modified source code but even that is not
// required as I can't check it anyway.
// But the code comes with no warranties or guarantees whatsoever.

module spm_test;

localparam CLK_PERIOD=100;

localparam WIDTH= 8; // width in bits
localparam L2D  = 8; // Log 2 Depth, 8 = 256 deep 
                     // Simulation parameters
localparam CLEAR= 1;
// Load file when starting
// in my case the simulation directory is not in tb but alongside it
localparam FILE = "../tb/xpm_test.pattern"; 


reg              clk; // system clock 
               
reg              enable; // access 
reg              write; // write 
reg  [L2D-1:0] address; // read/write address
reg  [WIDTH-1:0] wdata; // write data
wire [WIDTH-1:0] rdata;

integer a;
   initial
   begin
               
      enable   = 1'b0;
      write    = 1'b0;
      address  = 'b0;
      wdata    = 8'h0;
      for (a=0; a<8; a=a+1)
      begin
         @(posedge clk) #5;
         address <= a;
         enable  <= 1'b1;
         write   <= 1'b1;  
         wdata   <= a;  
      end
      for (a=0; a<8; a=a+1)
      begin
         @(posedge clk) #5;
         address <= a;
         enable  <= 1'b1;
         write   <= 1'b0;  
      end
      @(posedge clk)
      enable <= 1'b0;
		#500 $stop;
   end


spm

   #(
      .WIDTH (WIDTH),  // width in bits
      .L2D   (L2D)  ,  // Log 2 Depth, 8 = 256 deep 
      // Simulation parameters
      .CLEAR (CLEAR),
      .FILE  (FILE) 
   ) // parameters
spm_0 (
      .clk    (clk),     // system clock 
               
      .enable (enable),  // access 
      .write  (write),   // write 
      .address(address), // read/write address
      .wdata  (wdata),   // write data
      .rdata  (rdata) 
   );



   // Generate arbitrary clock.
   initial
   begin
      clk = 1'b0;
      forever
         #(CLK_PERIOD/2) clk = ~clk;
   end

endmodule
