/*
 * 
 * Vericon version 4.3. Generated Sat Sep 12 10:36:38 2015
 * Auto generated testbench
 *
 */
 
// Freeware September 2015, Fen Logic Ltd.
// This code is free and is delivered 'as is'.
// It comes without any warranty, to the extent permitted by applicable law.
// There are no restrictions to any use or re-use of this code
// in any form or shape. It would be nice if you keep my company name
// in the source or modified source code but even that is not
// required as I can't check it anyway.
// But the code comes with no warranties or guarantees whatsoever.

 //
 // NOT use self-checking code
 // The xcode is so simple: just verify the memory visually
 //

module spmbe_test;

localparam CLK_PERIOD=100;

localparam BYTES= 4; // width in bytes
localparam L2D  = 8; // Log 2 Depth, 8 = 256 deep  
localparam CLEAR= 1; // Clear menory when starting  
// Load file when starting
// in my case the simulation directory is not in tb but alongside it
localparam FILE = "../tb/spmbe_test.pattern"; 
       

reg                clk; // system clock 
               
reg                enable; // access 
reg                write; // write 
reg  [BYTES-1:0] bwe; // Byte write enable 
reg  [L2D-1:0] address; // read/write address
reg  [BYTES*8-1:0] wdata; // write data
wire [BYTES*8-1:0] rdata;

   initial
   begin

      clk      = 1'b0;
               
      enable   = 1'b0;
      write    = 1'b0;
      bwe      = 'b0;
      wdata    = 32'h44332211;
      for (address=0; address<8; address=address+1)
      begin
         @(posedge clk) #5;
         enable <= 1'b1;
         write  <= 1'b1;
         bwe = 1<<(address & 3);       
      end
      for (address=16; address<48; address=address+1)
      begin
         @(posedge clk) #5;
         enable <= 1'b1;
         write  <= 1'b1;
         bwe = address & 15;       
      end
      @(posedge clk)
      enable <= 1'b0;
		#500 $stop;
   end


spmbe

   #(
      .BYTES (BYTES),  // width in bytes
      .L2D   (L2D),    // Log 2 Depth, 8 = 256 deep 
      .CLEAR (CLEAR),     // Clear memory for sim
      .FILE  (FILE)
   ) // parameters
spmbe_0 (

      .clk    (clk),     // system clock 
               
      .enable (enable),  // access 
      .write  (write),   // write 
      .bwe    (bwe),     // Byte write enable 
      .address(address), // read/write address
      .wdata  (wdata),   // write data
      .rdata  (rdata) 
   );



   /* General clock & reset section
   always @(posedge clk or negedge some_reset)
   begin
      if (!some_reset)
      begin
      end
      else
      begin
      end
   end
   */

   // Generate arbitrary clock. Replace with your real clock
   initial
   begin
      clk = 1'b0;
      forever
         #(CLK_PERIOD/2) clk = ~clk;
   end

endmodule
